import * as i0 from '@angular/core';
import { EventEmitter, Directive, Output, NgModule } from '@angular/core';

class ElementLifeDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        this.init = new EventEmitter();
        this.viewInit = new EventEmitter();
        this.destroy = new EventEmitter();
    }
    ngOnInit() {
        this.init.emit(this.elementRef);
    }
    ngAfterViewInit() {
        this.viewInit.emit(this.elementRef);
    }
    ngOnDestroy() {
        this.destroy.emit(this.elementRef);
    }
}
ElementLifeDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
ElementLifeDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: ElementLifeDirective, selector: "[element-life]", outputs: { init: "init", viewInit: "viewInit", destroy: "destroy" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[element-life]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { init: [{
                type: Output
            }], viewInit: [{
                type: Output
            }], destroy: [{
                type: Output
            }] } });

class ElementLifeModule {
}
ElementLifeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ElementLifeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeModule, declarations: [ElementLifeDirective], exports: [ElementLifeDirective] });
ElementLifeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: ElementLifeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        ElementLifeDirective
                    ],
                    exports: [
                        ElementLifeDirective
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { ElementLifeDirective, ElementLifeModule };
//# sourceMappingURL=ngx-element-life.mjs.map
